/*
   Copyright 2018-2019 Zephyr Software, LLC.

   Licensed under the Apache License, Version 2.0 (the "License");
   you may not use this file except in compliance with the License.
   You may obtain a copy of the License at

       http://www.apache.org/licenses/LICENSE-2.0

   Unless required by applicable law or agreed to in writing, software
   distributed under the License is distributed on an "AS IS" BASIS,
   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
   See the License for the specific language governing permissions and
   limitations under the License.

*/
namespace IRDB_SDK
{

	class ArchitectureDescription_t
	{
		protected:
			ArchitectureDescription_t() {}
			ArchitectureDescription_t(const ArchitectureDescription_t& copy) = delete;
		public:
			~ArchitectureDescription_t() {}

			virtual int             getBitWidth()    const = 0;
			virtual ADFileType_t    getFileType()    const = 0;
			virtual ADMachineType_t getMachineType() const = 0;
			virtual VirtualOffset_t getFileBase()    const = 0;

			virtual void setFileType(const ADFileType_t t)       = 0;
			virtual void setBitWidth(const int _bits)            = 0;
			virtual void setMachineType(const ADMachineType_t t) = 0;
			virtual void setFileBase(const VirtualOffset_t fb)   = 0;

	};

}
