/*
   Copyright 2018-2019 Zephyr Software, LLC.

   Licensed under the Apache License, Version 2.0 (the "License");
   you may not use this file except in compliance with the License.
   You may obtain a copy of the License at

       http://www.apache.org/licenses/LICENSE-2.0

   Unless required by applicable law or agreed to in writing, software
   distributed under the License is distributed on an "AS IS" BASIS,
   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
   See the License for the specific language governing permissions and
   limitations under the License.

*/

namespace IRDB_SDK
{
	using namespace std;

	class pqxxDB_t : virtual public DBinterface_t
	{
		protected:
			pqxxDB_t() {}
			pqxxDB_t(const pqxxDB_t& copy) = delete;
		public:
			virtual ~pqxxDB_t() { };

			virtual void         issueQuery(const string& query)         = 0;
			virtual void         issueQuery(stringstream & query) = 0;
			virtual void         moveToNextRow()                  = 0;
			virtual string       getResultColumn(const string& colname)  = 0;
			virtual bool         isDone()                         = 0;
			virtual void         commit()                         = 0;
			virtual pqxx::connection&  
				             getConnection()                  = 0; 
			virtual pqxx::work&  getTransaction()                 = 0; 

			static unique_ptr<pqxxDB_t> factory();

	};
}
