/*
   Copyright 2018-2019 Zephyr Software, LLC.

   Licensed under the Apache License, Version 2.0 (the "License");
   you may not use this file except in compliance with the License.
   You may obtain a copy of the License at

       http://www.apache.org/licenses/LICENSE-2.0

   Unless required by applicable law or agreed to in writing, software
   distributed under the License is distributed on an "AS IS" BASIS,
   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
   See the License for the specific language governing permissions and
   limitations under the License.

*/

namespace IRDB_SDK
{
	using namespace std;
	using  SyscallNumber_t = enum SyscallNumber
		{
			sntUnknown=-1,
		};

	class  SyscallSite_t
	{
		protected:
			SyscallSite_t() { }
			SyscallSite_t(const SyscallSite_t& copy) = delete;
		public:
			virtual ~SyscallSite_t() { }
			virtual Instruction_t*  getSyscallSite()   const = 0 ;
			virtual Instruction_t*  getSite()          const = 0 ;
			virtual SyscallNumber_t getSyscallNumber() const = 0 ;
	};

	using SyscallSiteSet_t = set<SyscallSite_t*>;

	class Syscalls_t
	{
		protected:
			Syscalls_t() { }
			Syscalls_t(const Syscalls_t& copy) = delete;
		public:
			virtual ~Syscalls_t() { }
		// getters
			virtual const SyscallSiteSet_t& getSyscalls() const = 0;
			virtual SyscallSiteSet_t& getSyscalls() = 0;
		// factories
			static unique_ptr<Syscalls_t> factory(FileIR_t *the_firp); 
	};

}

