/*
   Copyright 2018-2019 Zephyr Software, LLC.

   Licensed under the Apache License, Version 2.0 (the "License");
   you may not use this file except in compliance with the License.
   You may obtain a copy of the License at

       http://www.apache.org/licenses/LICENSE-2.0

   Unless required by applicable law or agreed to in writing, software
   distributed under the License is distributed on an "AS IS" BASIS,
   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
   See the License for the specific language governing permissions and
   limitations under the License.

*/

namespace IRDB_SDK
{

	class InstructionPredecessors_t
	{
		protected:
			InstructionPredecessors_t() { }
			InstructionPredecessors_t(const InstructionPredecessors_t& copy) = delete;
		public:
			virtual ~InstructionPredecessors_t() { } 

		// getters
			virtual const InstructionSet_t& getPredecessors(const Instruction_t* i)  const = 0;
			virtual const InstructionSet_t& operator[] (const Instruction_t* i)     const = 0;

		// factories
			static unique_ptr<InstructionPredecessors_t> factory(FileIR_t* firp=nullptr);

	};

}
